"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.replaceHomeFolder = exports["default"] = void 0;var _utils = require("../systemManager/utils");

var androidPlatform = 'linux';
var tizenPlatform = 'ubuntu';
var tizenExtension = 'bin';

if (_utils.isSystemWin) {
  androidPlatform = 'windows';
  tizenPlatform = 'windows';
  tizenExtension = 'exe';
}

if (process.platform === 'darwin') {
  tizenPlatform = 'macos';
  tizenExtension = 'dmg';
}

var replaceHomeFolder = function replaceHomeFolder(p) {
  if (_utils.isSystemWin) return p.replace('~', process.env.USERPROFILE);
  return p.replace('~', process.env.HOME);
};exports.replaceHomeFolder = replaceHomeFolder;var _default =

{
  android: {
    sdkUrl: "https://dl.google.com/android/repository/sdk-tools-".concat(androidPlatform, "-4333796.zip"),
    downloadLocation: replaceHomeFolder("~/sdk-tools-".concat(
    androidPlatform, "-4333796.zip")),

    location: replaceHomeFolder('~/Android') },

  tizen: {
    sdkUrl: "http://download.tizen.org/sdk/Installer/tizen-studio_3.3/web-ide_Tizen_Studio_3.3_".concat(
    tizenPlatform, "-64.").concat(
    tizenExtension),
    downloadLocation: replaceHomeFolder("~/web-ide_Tizen_Studio_3.3_".concat(
    tizenPlatform, "-64.").concat(tizenExtension)) },


  webos: {
    downloadLink: 'http://webostv.developer.lge.com/sdk/installation/#' } };exports["default"] = _default;
//# sourceMappingURL=config.js.map