"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.configureGit = void 0;var _path = _interopRequireDefault(require("path"));
var _exec = require("./exec");
var _fileutils = require("./fileutils");
var _logger = require("./logger");function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {try {var info = gen[key](arg);var value = info.value;} catch (error) {reject(error);return;}if (info.done) {resolve(value);} else {Promise.resolve(value).then(_next, _throw);}}function _asyncToGenerator(fn) {return function () {var self = this,args = arguments;return new Promise(function (resolve, reject) {var gen = fn.apply(self, args);function _next(value) {asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);}function _throw(err) {asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);}_next(undefined);});};}

var configureGit = /*#__PURE__*/function () {var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(c) {var projectPath;return regeneratorRuntime.wrap(function _callee$(_context) {while (1) {switch (_context.prev = _context.next) {case 0:
            projectPath = c.paths.project.dir;
            (0, _logger.logTask)("configureGit:".concat(projectPath));if (

            (0, _fileutils.fsExistsSync)(_path["default"].join(projectPath, '.git'))) {_context.next = 14;break;}
            (0, _logger.logInfo)('Your project does not have a git repo. Creating one...DONE');if (!
            (0, _exec.commandExistsSync)('git')) {_context.next = 13;break;}_context.next = 7;return (
              (0, _exec.executeAsync)('git init', { cwd: projectPath }));case 7:_context.next = 9;return (
              (0, _exec.executeAsync)('git add -A', { cwd: projectPath }));case 9:_context.next = 11;return (
              (0, _exec.executeAsync)('git commit -m "Initial"', { cwd: projectPath }));case 11:_context.next = 14;break;case 13:

            (0, _logger.logWarning)(
            "We tried to create a git repo inside your project but you don't seem to have git installed");case 14:case "end":return _context.stop();}}}, _callee);}));return function configureGit(_x) {return _ref.apply(this, arguments);};}();exports.configureGit = configureGit;
//# sourceMappingURL=gitUtils.js.map