"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.printIntoBox = exports.printBoxStart = exports.printBoxEnd = exports.printArrIntoBox = exports.logWelcome = exports.logWarning = exports.logToSummary = exports.logTask = exports.logSummary = exports.logSuccess = exports.logRaw = exports.logInitialize = exports.logInitTask = exports.logInfo = exports.logHook = exports.logExitTask = exports.logError = exports.logEnd = exports.logDebug = exports.logComplete = exports.logAppInfo = exports.logAndSave = exports.isInfoEnabled = exports.getCurrentCommand = exports["default"] = exports.chalk = void 0;
var _chalk2 = _interopRequireDefault(require("chalk"));
var _stripAnsi = _interopRequireDefault(require("strip-ansi"));
var _utils = require("./utils");function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function ownKeys(object, enumerableOnly) {var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {var symbols = Object.getOwnPropertySymbols(object);enumerableOnly && (symbols = symbols.filter(function (sym) {return Object.getOwnPropertyDescriptor(object, sym).enumerable;})), keys.push.apply(keys, symbols);}return keys;}function _objectSpread(target) {for (var i = 1; i < arguments.length; i++) {var source = null != arguments[i] ? arguments[i] : {};i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {_defineProperty(target, key, source[key]);}) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));});}return target;}function _defineProperty(obj, key, value) {if (key in obj) {Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });} else {obj[key] = value;}return obj;}

var ICN_ROCKET = _utils.isSystemWin ? 'RNV' : '🚀';
var ICN_UNICORN = _utils.isSystemWin ? 'unicorn' : '🦄';

var _chalkCols = {
  white: function white(v) {return v;},
  green: function green(v) {return v;},
  red: function red(v) {return v;},
  yellow: function yellow(v) {return v;},
  "default": function _default(v) {return v;},
  gray: function gray(v) {return v;},
  grey: function grey(v) {return v;},
  blue: function blue(v) {return v;},
  cyan: function cyan(v) {return v;},
  magenta: function magenta(v) {return v;} };

_chalkCols.rgb = function () {return function (v) {return v;};};
_chalkCols.bold = _chalkCols;
var _chalkMono = _objectSpread({},
_chalkCols);


var currentChalk = _chalk2["default"];

var RNV = 'ReNative';

var chalk = function chalk() {return currentChalk || _chalk2["default"];};exports.chalk = chalk;

var logWelcome = function logWelcome() {var _cnf$files, _cnf$files$rnv, _cnf$files$rnv$packag;
  // prettier-ignore
  var str = _defaultColor("\n\u250C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2510\n\u2502                                                                              \u2502\n\u2502        ".concat(


  currentChalk.red('██████╗'), " \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557").concat(currentChalk.red('███╗   ██╗'), " \u2588\u2588\u2588\u2588\u2588\u2557 \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557\u2588\u2588\u2557").concat(currentChalk.red('██╗   ██╗'), "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557       \u2502\n\u2502        ").concat(
  currentChalk.red('██╔══██╗'), "\u2588\u2588\u2554\u2550\u2550\u2550\u2550\u255D").concat(currentChalk.red('████╗  ██║'), "\u2588\u2588\u2554\u2550\u2550\u2588\u2588\u2557\u255A\u2550\u2550\u2588\u2588\u2554\u2550\u2550\u255D\u2588\u2588\u2551").concat(currentChalk.red('██║   ██║'), "\u2588\u2588\u2554\u2550\u2550\u2550\u2550\u255D       \u2502\n\u2502        ").concat(
  currentChalk.red('██████╔╝'), "\u2588\u2588\u2588\u2588\u2588\u2557  ").concat(currentChalk.red('██╔██╗ ██║'), "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2551   \u2588\u2588\u2551   \u2588\u2588\u2551").concat(currentChalk.red('██║   ██║'), "\u2588\u2588\u2588\u2588\u2588\u2557         \u2502\n\u2502        ").concat(
  currentChalk.red('██╔══██╗'), "\u2588\u2588\u2554\u2550\u2550\u255D  ").concat(currentChalk.red('██║╚██╗██║'), "\u2588\u2588\u2554\u2550\u2550\u2588\u2588\u2551   \u2588\u2588\u2551   \u2588\u2588\u2551").concat(currentChalk.red('╚██╗ ██╔╝'), "\u2588\u2588\u2554\u2550\u2550\u255D         \u2502\n\u2502        ").concat(
  currentChalk.red('██║  ██║'), "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557").concat(currentChalk.red('██║ ╚████║'), "\u2588\u2588\u2551  \u2588\u2588\u2551   \u2588\u2588\u2551   \u2588\u2588\u2551").concat(currentChalk.red(' ╚████╔╝ '), "\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557       \u2502\n\u2502        ").concat(
  currentChalk.red('╚═╝  ╚═╝'), "\u255A\u2550\u2550\u2550\u2550\u2550\u2550\u255D").concat(currentChalk.red('╚═╝  ╚═══╝'), "\u255A\u2550\u255D  \u255A\u2550\u255D   \u255A\u2550\u255D   \u255A\u2550\u255D").concat(currentChalk.red('  ╚═══╝  '), "\u255A\u2550\u2550\u2550\u2550\u2550\u2550\u255D       \u2502\n\u2502                                                                              \u2502\n"));



  if ((_cnf$files = cnf().files) !== null && _cnf$files !== void 0 && (_cnf$files$rnv = _cnf$files.rnv) !== null && _cnf$files$rnv !== void 0 && (_cnf$files$rnv$packag = _cnf$files$rnv["package"]) !== null && _cnf$files$rnv$packag !== void 0 && _cnf$files$rnv$packag.version) {var _cnf$rnvVersion, _cnf$rnvVersion$inclu;
    cnf().rnvVersion = cnf().files.rnv["package"].version;
    str += printIntoBox("      Version: ".concat(currentChalk.green(cnf().rnvVersion)), 1);
    if ((_cnf$rnvVersion = cnf().rnvVersion) !== null && _cnf$rnvVersion !== void 0 && (_cnf$rnvVersion$inclu = _cnf$rnvVersion.includes) !== null && _cnf$rnvVersion$inclu !== void 0 && _cnf$rnvVersion$inclu.call(_cnf$rnvVersion, 'alpha')) {
      str += printIntoBox("      ".concat(
      currentChalk.yellow(
      'WARNING: this is a prerelease version.')),

      1);

    }
  }
  str += printIntoBox("      ".concat(currentChalk.grey('https://renative.org')), 1);
  str += printIntoBox("      ".concat(ICN_ROCKET, " ").concat(currentChalk.yellow('Firing up!...')), 1);
  str += printIntoBox("      $ ".concat(currentChalk.cyan(getCurrentCommand(true))), 1);
  if (global.timeStart) {
    str += printIntoBox("      Start Time: ".concat(
    currentChalk.grey(global.timeStart.toLocaleString())));

  }
  str += printIntoBox('');
  str += printBoxEnd();
  str += '\n';

  console.log(str);
};exports.logWelcome = logWelcome;

var _currentProcess;
var _isInfoEnabled = false;
var _infoFilter = [];
var _c;
var _isMono = false;
var _defaultColor;
var _highlightColor;
var _analytics;

var cnf = function cnf() {
  if (!_c) {
    _configureLogger(global.RNV_CONFIG, global.RNV_ANALYTICS);
  }
  return _c;
};

var _configureLogger = function _configureLogger(c, analytics) {var _c$program$info, _c$program$info$split;
  global._messages = [];
  _c = c;
  if (!global.timeStart) global.timeStart = new Date();
  _currentProcess = c.process;
  _isInfoEnabled = !!c.program.info;
  _infoFilter = (_c$program$info = c.program.info) === null || _c$program$info === void 0 ? void 0 : (_c$program$info$split = _c$program$info.split) === null || _c$program$info$split === void 0 ? void 0 : _c$program$info$split.call(_c$program$info, ',');
  _isMono = c.program.mono;
  _analytics = analytics;
  if (_isMono) {
    currentChalk = _chalkMono;
  }
  _updateDefaultColors();
  RNV = getCurrentCommand();
};

var _updateDefaultColors = function _updateDefaultColors() {
  _defaultColor = currentChalk.gray;
  _highlightColor = currentChalk.green;
};
_updateDefaultColors();

var logAndSave = function logAndSave(msg, skipLog) {
  if (global._messages && !global._messages.includes(msg)) global._messages.push(msg);
  if (!skipLog) console.log("".concat(msg));
};exports.logAndSave = logAndSave;

var PRIVATE_PARAMS = ['-k', '--key'];

var getCurrentCommand = function getCurrentCommand() {var excludeDollar = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  var argArr = cnf().process.argv.slice(2);
  var hideNext = false;
  var output = argArr.
  map(function (v) {
    if (hideNext) {
      hideNext = false;
      return '********';
    }
    if (PRIVATE_PARAMS.includes(v)) {
      hideNext = true;
    }

    return v;
  }).
  join(' ');
  var dollar = excludeDollar ? '' : '$ ';
  return "".concat(dollar, "rnv ").concat(output);
};exports.getCurrentCommand = getCurrentCommand;

var logToSummary = function logToSummary(v, sanitizePaths) {
  var _v = sanitizePaths ? _sanitizePaths(v) : v;
  global._messages.push("\n".concat(_v));
};exports.logToSummary = logToSummary;

var logRaw = function logRaw() {for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {args[_key] = arguments[_key];}
  console.log.apply(null, args);
};exports.logRaw = logRaw;

var logSummary = function logSummary() {var _cnf$files2, _cnf$files2$project, _cnf$buildConfig, _cnf$runtime, _cnf$buildConfig2, _cnf$buildConfig2$_me, _cnf$runtime3, _cnf$runtime5, _cnf$runtime7, _cnf$program, _cnf$program3, _cnf$runtime9, _cnf$runtime9$support, _cnf$files3, _cnf$files3$project, _cnf$files3$project$c, _cnf$runtime10;var header = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'SUMMARY';
  var logContent = printIntoBox("All good as ".concat(ICN_UNICORN, " "));
  if (global._messages && global._messages.length) {
    logContent = '';
    global._messages.forEach(function (m) {
      logContent += "\u2502 ".concat(m, "\n");
    });
  }

  var timeString = '';
  global.timeEnd = new Date();
  timeString = "| ".concat(global.timeEnd.toLocaleString());

  var str = printBoxStart("".concat(ICN_ROCKET, "  ").concat(header, " ").concat(timeString), getCurrentCommand());

  str += printIntoBox("ReNative Version: ".concat(
  _highlightColor(cnf().rnvVersion)),
  1);

  if ((_cnf$files2 = cnf().files) !== null && _cnf$files2 !== void 0 && (_cnf$files2$project = _cnf$files2.project) !== null && _cnf$files2$project !== void 0 && _cnf$files2$project["package"]) {
    str += printIntoBox("Project Name ($package.name): ".concat(
    _highlightColor(
    cnf().files.project["package"].name)),

    1);

    str += printIntoBox("Project Version ($package.version): ".concat(
    _highlightColor(
    cnf().files.project["package"].version)),

    1);

  }

  if ((_cnf$buildConfig = cnf().buildConfig) !== null && _cnf$buildConfig !== void 0 && _cnf$buildConfig.workspaceID) {
    str += printIntoBox("Workspace ($.workspaceID): ".concat(
    _highlightColor(cnf().buildConfig.workspaceID)),
    1);

  }
  if (cnf().platform) {
    str += printIntoBox("Platform (-p): ".concat(_highlightColor(cnf().platform)), 1);
  }
  if ((_cnf$runtime = cnf().runtime) !== null && _cnf$runtime !== void 0 && _cnf$runtime.engine) {var _cnf$runtime2, _cnf$runtime2$engine, _cnf$runtime2$engine$;
    var addon = '';
    if (cnf().platform) {
      addon = " ($.platforms.".concat(cnf().platform, ".engine)");
    }
    str += printIntoBox("Engine".concat(addon, ": ").concat(
    _highlightColor((_cnf$runtime2 = cnf().runtime) === null || _cnf$runtime2 === void 0 ? void 0 : (_cnf$runtime2$engine = _cnf$runtime2.engine) === null || _cnf$runtime2$engine === void 0 ? void 0 : (_cnf$runtime2$engine$ = _cnf$runtime2$engine.config) === null || _cnf$runtime2$engine$ === void 0 ? void 0 : _cnf$runtime2$engine$.id)),
    1);
  }
  if ((_cnf$buildConfig2 = cnf().buildConfig) !== null && _cnf$buildConfig2 !== void 0 && (_cnf$buildConfig2$_me = _cnf$buildConfig2._meta) !== null && _cnf$buildConfig2$_me !== void 0 && _cnf$buildConfig2$_me.currentAppConfigId) {var _cnf$buildConfig$_met;
    str += printIntoBox("App Config (-c): ".concat(
    _highlightColor((_cnf$buildConfig$_met =
    cnf().buildConfig._meta) === null || _cnf$buildConfig$_met === void 0 ? void 0 : _cnf$buildConfig$_met.currentAppConfigId)),

    1);

  }
  if ((_cnf$runtime3 = cnf().runtime) !== null && _cnf$runtime3 !== void 0 && _cnf$runtime3.scheme) {var _cnf$runtime4;
    str += printIntoBox("Build Scheme (-s): ".concat(
    _highlightColor((_cnf$runtime4 = cnf().runtime) === null || _cnf$runtime4 === void 0 ? void 0 : _cnf$runtime4.scheme)),
    1);

  }
  if ((_cnf$runtime5 = cnf().runtime) !== null && _cnf$runtime5 !== void 0 && _cnf$runtime5.bundleAssets) {var _cnf$runtime6;
    str += printIntoBox("Bundle assets ($.platforms.".concat(
    cnf().platform, ".bundleAssets): ").concat(
    _highlightColor(!!((_cnf$runtime6 = cnf().runtime) !== null && _cnf$runtime6 !== void 0 && _cnf$runtime6.bundleAssets))),
    1);

  }
  if ((_cnf$runtime7 = cnf().runtime) !== null && _cnf$runtime7 !== void 0 && _cnf$runtime7.target) {var _cnf$runtime8;
    str += printIntoBox("Target (-t): ".concat(
    _highlightColor((_cnf$runtime8 = cnf().runtime) === null || _cnf$runtime8 === void 0 ? void 0 : _cnf$runtime8.target)),
    1);

  }
  if ((_cnf$program = cnf().program) !== null && _cnf$program !== void 0 && _cnf$program.reset) {var _cnf$program2;
    str += printIntoBox("Reset Project (-r): ".concat(
    _highlightColor(!!((_cnf$program2 = cnf().program) !== null && _cnf$program2 !== void 0 && _cnf$program2.reset))),
    1);

  }
  if ((_cnf$program3 = cnf().program) !== null && _cnf$program3 !== void 0 && _cnf$program3.resetHard) {var _cnf$program4;
    str += printIntoBox("Reset Project and Assets (-R): ".concat(
    _highlightColor(!!((_cnf$program4 = cnf().program) !== null && _cnf$program4 !== void 0 && _cnf$program4.resetHard))),
    1);

  }
  if ((_cnf$runtime9 = cnf().runtime) !== null && _cnf$runtime9 !== void 0 && (_cnf$runtime9$support = _cnf$runtime9.supportedPlatforms) !== null && _cnf$runtime9$support !== void 0 && _cnf$runtime9$support.length) {
    var plats = cnf().runtime.supportedPlatforms.map(function (v) {return "".concat(v.platform).concat(v.isConnected ? '' : '(ejected)');});
    str += printArrIntoBox(plats, 'Supported Platforms: ');
  }

  if ((_cnf$files3 = cnf().files) !== null && _cnf$files3 !== void 0 && (_cnf$files3$project = _cnf$files3.project) !== null && _cnf$files3$project !== void 0 && (_cnf$files3$project$c = _cnf$files3$project.config) !== null && _cnf$files3$project$c !== void 0 && _cnf$files3$project$c.defaults) {
    var defaultProjectConfigs = cnf().files.project.config.defaults;
    if (defaultProjectConfigs !== null && defaultProjectConfigs !== void 0 && defaultProjectConfigs.template) {
      str += printIntoBox("Master Template: ".concat(
      _highlightColor(
      defaultProjectConfigs.template)),

      1);

    }
  }

  if (cnf().process) {var _cnf$process$versions;
    var envString = "".concat(cnf().process.platform, " | ").concat(
    cnf().process.arch, " | node v").concat((_cnf$process$versions = cnf().process.versions) === null || _cnf$process$versions === void 0 ? void 0 : _cnf$process$versions.node);
    str += printIntoBox("Env Info: ".concat(currentChalk.gray(envString)), 1);
  }

  if (global.timeEnd) {
    str += printIntoBox("Executed Time: ".concat(
    currentChalk.yellow(
    _msToTime(global.timeEnd - global.timeStart))),

    1);

  }

  str += printIntoBox('');
  str += logContent.replace(/\n\s*\n\s*\n/g, '\n\n');
  str += printIntoBox('');
  if ((_cnf$runtime10 = cnf().runtime) !== null && _cnf$runtime10 !== void 0 && _cnf$runtime10.platformBuildsProjectPath) {
    str += printIntoBox('Project location:');
    str += printIntoBox("".concat(currentChalk.cyan(_sanitizePaths(cnf().runtime.platformBuildsProjectPath))), 1);
  }
  str += printBoxEnd();

  console.log(str);
};exports.logSummary = logSummary;

var _msToTime = function _msToTime(seconds) {
  var s = seconds;
  var ms = s % 1000;
  s = (s - ms) / 1000;
  var secs = s % 60;
  s = (s - secs) / 60;
  var mins = s % 60;
  var hrs = (s - mins) / 60;

  return "".concat(hrs, "h:").concat(mins, "m:").concat(secs, "s:").concat(ms, "ms");
};

var _getCurrentTask = function _getCurrentTask() {return cnf()._currentTask ? currentChalk.grey(" [".concat(cnf()._currentTask, "]")) : '';};

var _sanitizePaths = function _sanitizePaths(msg) {var _cnf$paths, _cnf$paths$project;
  if (msg !== null && msg !== void 0 && msg.replace && (_cnf$paths = cnf().paths) !== null && _cnf$paths !== void 0 && (_cnf$paths$project = _cnf$paths.project) !== null && _cnf$paths$project !== void 0 && _cnf$paths$project.dir) {
    return msg.replace(new RegExp(cnf().paths.project.dir, 'g'), '.');
  }
  return msg;
};

var TASK_COUNTER = {};

var logTask = function logTask(task, customChalk) {
  if (!TASK_COUNTER[task]) TASK_COUNTER[task] = 0;
  TASK_COUNTER[task] += 1;
  var taskCount = currentChalk.grey("[".concat(TASK_COUNTER[task], "]"));
  var msg = '';
  if (typeof customChalk === 'string') {
    msg = "".concat(currentChalk.green("[ task ]".concat(
    _getCurrentTask(), " ").concat(task))).concat(taskCount, " ").concat(currentChalk.grey(customChalk));
  } else if (customChalk) {
    msg = customChalk("[ task ]".concat(_getCurrentTask(), " ").concat(task).concat(taskCount));
  } else {
    msg = currentChalk.green("[ task ]".concat(_getCurrentTask(), " ").concat(task).concat(taskCount));
  }

  console.log(_sanitizePaths(msg));
};exports.logTask = logTask;


var logInitTask = function logInitTask(task, customChalk) {
  var msg = '';
  if (typeof customChalk === 'string') {
    msg = "".concat(currentChalk.rgb(183, 84, 117)("[ task ] ".concat(task)), " ").concat(currentChalk.grey(customChalk));
  } else if (customChalk) {
    msg = customChalk("[ task ] ".concat(task));
  } else {
    msg = currentChalk.rgb(183, 84, 117)("[ task ] ".concat(task));
  }

  console.log(msg);
};exports.logInitTask = logInitTask;

var logExitTask = function logExitTask(task, customChalk) {
  var msg = '';
  if (typeof customChalk === 'string') {
    msg = "".concat(currentChalk.rgb(183, 84, 117)("[ task ] ".concat(task)), " ").concat(currentChalk.grey(customChalk));
  } else if (customChalk) {
    msg = customChalk("[ task ] ".concat(task));
  } else {
    msg = currentChalk.rgb(183, 84, 117)("[ task ] ".concat(task));
  }

  console.log(msg);
};exports.logExitTask = logExitTask;

var logHook = function logHook() {var hook = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';var msg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  console.log("".concat(currentChalk.rgb(127, 255, 212)("[ hook ]".concat(_getCurrentTask(), " ").concat(
  hook)), " ").concat(currentChalk.grey(_sanitizePaths(msg))));
};exports.logHook = logHook;

var logWarning = function logWarning(msg) {
  logAndSave(currentChalk.yellow("[ warn ]".concat(_getCurrentTask(), " ").concat(_sanitizePaths(msg))));
};exports.logWarning = logWarning;

var logInfo = function logInfo(msg) {
  console.log(currentChalk.cyan("[ info ]".concat(_getCurrentTask(), " ").concat(_sanitizePaths(msg))));
};exports.logInfo = logInfo;

var logDebug = function logDebug() {
  if (_isInfoEnabled) {for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {args[_key2] = arguments[_key2];}
    if (_infoFilter) {
      var firstArg = args[0];

      if (_infoFilter.filter(function (v) {var _firstArg$includes;return firstArg === null || firstArg === void 0 ? void 0 : (_firstArg$includes = firstArg.includes) === null || _firstArg$includes === void 0 ? void 0 : _firstArg$includes.call(firstArg, v);}).length) {
        console.log.apply(null, args);
      }
    } else {
      console.log.apply(null, args);
    }
  }
};exports.logDebug = logDebug;

var isInfoEnabled = function isInfoEnabled() {return _isInfoEnabled;};exports.isInfoEnabled = isInfoEnabled;

var logComplete = function logComplete() {var isEnd = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  console.log(currentChalk.bold.white("\n ".concat(RNV, " - Done! ").concat(ICN_ROCKET)));
  if (isEnd) logEnd(0);
};exports.logComplete = logComplete;

var logSuccess = function logSuccess(msg) {
  logAndSave(currentChalk.magenta("[ success ]".concat(_getCurrentTask(), " ").concat(_sanitizePaths(msg))));
};exports.logSuccess = logSuccess;

var logError = function logError(e) {var isEnd = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;var skipAnalytics = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  if (!skipAnalytics && !!_analytics) {var _cnf$runtime11, _cnf$runtime11$engine, _cnf$runtime11$engine2, _cnf$runtime12, _cnf$process, _cnf$process2, _cnf$process3, _cnf$process3$version;
    var extra = {
      command: getCurrentCommand(),
      version: cnf().rnvVersion,
      engine: (_cnf$runtime11 = cnf().runtime) === null || _cnf$runtime11 === void 0 ? void 0 : (_cnf$runtime11$engine = _cnf$runtime11.engine) === null || _cnf$runtime11$engine === void 0 ? void 0 : (_cnf$runtime11$engine2 = _cnf$runtime11$engine.config) === null || _cnf$runtime11$engine2 === void 0 ? void 0 : _cnf$runtime11$engine2.id,
      platform: cnf().platform,
      bundleAssets: !!((_cnf$runtime12 = cnf().runtime) !== null && _cnf$runtime12 !== void 0 && _cnf$runtime12.bundleAssets),
      os: (_cnf$process = cnf().process) === null || _cnf$process === void 0 ? void 0 : _cnf$process.platform,
      arch: (_cnf$process2 = cnf().process) === null || _cnf$process2 === void 0 ? void 0 : _cnf$process2.arch,
      node: (_cnf$process3 = cnf().process) === null || _cnf$process3 === void 0 ? void 0 : (_cnf$process3$version = _cnf$process3.versions) === null || _cnf$process3$version === void 0 ? void 0 : _cnf$process3$version.node };

    _analytics.captureException(e, { extra: extra });
  }

  if (e && e.message) {
    logAndSave(
    currentChalk.red("[ error ]".concat(_getCurrentTask(), " ").concat(e.message, "\n").concat(e.stack)),
    isEnd);

  } else {
    logAndSave(currentChalk.red("[ error ]".concat(_getCurrentTask(), " ").concat(e)), isEnd);
  }
  cnf().runtime.keepSessionActive = false;
  if (isEnd) logEnd(1);
};exports.logError = logError;

var logEnd = function logEnd(code) {
  logSummary();
  if (_currentProcess && !!_analytics) {
    _analytics.teardown().then(function () {
      _currentProcess.exit(code);
    });
  }
};exports.logEnd = logEnd;

var logInitialize = function logInitialize() {
  logWelcome();
};exports.logInitialize = logInitialize;

var logAppInfo = function logAppInfo(c) {
  logInfo("Current App Config: ".concat(currentChalk.bold.white(
  c.runtime.appId)));

};exports.logAppInfo = logAppInfo;

var printIntoBox = function printIntoBox(str) {
  var output = _defaultColor('│  ');

  var strLenDiff = str.length - (0, _stripAnsi["default"])(str).length;
  output += _defaultColor(str);
  var maxLen = 76;
  var len = maxLen - (str.length - strLenDiff);
  if (len > 0) {
    for (var i = 0; i < len; i++) {
      output += ' ';
    }
    output += _defaultColor('│\n');
  } else {
    output += _defaultColor('\n');
  }


  return output;
};exports.printIntoBox = printIntoBox;

var printArrIntoBox = function printArrIntoBox(arr) {var prefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var output = '';
  var stringArr = '';
  var i = 0;
  arr.forEach(function (v) {
    var l = i === 0 ? 60 - _defaultColor(prefix).length : 60;
    if (stringArr.length > l) {
      if (i === 0 && prefix.length) {
        output += printIntoBox("".concat(
        _defaultColor(prefix)).concat(_defaultColor(stringArr)),
        2);

      } else {
        output += printIntoBox(_defaultColor(stringArr), 1);
      }

      stringArr = '';
      i++;
    }
    stringArr += "".concat(v, ", ");
    // stringArr[i] += `${c.platformDefaults[v].icon} ${currentChalk.white(v)}, `;
  });
  if (i === 0 && prefix.length) {
    output += printIntoBox("".concat(
    _defaultColor(prefix)).concat(_defaultColor(stringArr.slice(0, -2))),
    2);

  } else {
    output += printIntoBox(_defaultColor(stringArr.slice(0, -2)), 1);
  }

  return output;
};exports.printArrIntoBox = printArrIntoBox;

var printBoxStart = function printBoxStart(str, str2) {
  var output = _defaultColor(
  '┌──────────────────────────────────────────────────────────────────────────────┐\n');

  output += printIntoBox(str);
  output += printIntoBox(str2 || '');
  output += _defaultColor(
  '├──────────────────────────────────────────────────────────────────────────────┤\n');

  return output;
};exports.printBoxStart = printBoxStart;

var printBoxEnd = function printBoxEnd() {return _defaultColor(
  '└──────────────────────────────────────────────────────────────────────────────┘');};exports.printBoxEnd = printBoxEnd;var _default2 =


{
  chalk: chalk,
  logHook: logHook,
  logEnd: logEnd,
  logInfo: logInfo,
  logTask: logTask,
  logError: logError,
  logDebug: logDebug,
  logAppInfo: logAppInfo,
  logWarning: logWarning,
  logSuccess: logSuccess,
  logWelcome: logWelcome,
  logComplete: logComplete,
  logInitialize: logInitialize };exports["default"] = _default2;
//# sourceMappingURL=logger.js.map