"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.isTemplateInstalled = exports.getTemplateOptions = exports.getInstalledTemplateOptions = exports.configureTemplateFiles = exports.configureEntryPoint = exports.checkIfTemplateConfigured = exports.applyTemplate = void 0;var _path = _interopRequireDefault(require("path"));
var _inquirer = _interopRequireDefault(require("inquirer"));

var _constants = require("../constants");



var _fileutils = require("../systemManager/fileutils");










var _logger = require("../systemManager/logger");







var _prompt = require("../../cli/prompt");
var _common = require("../common");
var _configManager = require("../configManager");




var _resolve = require("../systemManager/resolve");
var _npmUtils = require("../systemManager/npmUtils");function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {try {var info = gen[key](arg);var value = info.value;} catch (error) {reject(error);return;}if (info.done) {resolve(value);} else {Promise.resolve(value).then(_next, _throw);}}function _asyncToGenerator(fn) {return function () {var self = this,args = arguments;return new Promise(function (resolve, reject) {var gen = fn.apply(self, args);function _next(value) {asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);}function _throw(err) {asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);}_next(undefined);});};}

var checkIfTemplateConfigured = /*#__PURE__*/function () {var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(c) {return regeneratorRuntime.wrap(function _callee$(_context) {while (1) {switch (_context.prev = _context.next) {case 0:
            (0, _logger.logTask)('checkIfTemplateConfigured');if (!(
            c.program.skipDependencyCheck || c.files.project.config.isTemplate)) {_context.next = 3;break;}return _context.abrupt("return", true);case 3:if (
            c.buildConfig.templates) {_context.next = 6;break;}
            (0, _logger.logWarning)("Your ".concat(
            (0, _logger.chalk)().white(
            c.paths.project.config), " does not contain ").concat(
            (0, _logger.chalk)().white(
            'templates'), " object. ReNative will skip template generation"));return _context.abrupt("return",


            false);case 6:

            Object.keys(c.buildConfig.templates).forEach(function (k) {
              var obj = c.buildConfig.templates[k];
              if (
              !(0, _resolve.doResolve)(k.version, false, { basedir: '../' }) &&
              !(0, _resolve.doResolve)(k, false))
              {
                (0, _logger.logInfo)("Your ".concat(
                (0, _logger.chalk)().white("".concat(
                k, "@").concat(obj.version)), " template is missing in renative.json. CONFIGURING...DONE"));


                c._requiresNpmInstall = true;
                c.runtime.requiresBootstrap = true;
              }
              if (c.files.project["package"].devDependencies) {
                if (c.files.project["package"].devDependencies[k] !== obj.version) {
                  (0, _logger.logInfo)("Updating template ".concat(
                  (0, _logger.chalk)().white("".concat(
                  k)), " => ").concat(
                  (0, _logger.chalk)().green(obj.version), ". ...DONE"));

                }

                c.files.project["package"].devDependencies[k] = obj.version;
              }
            });

            _writeObjectSync(c, c.paths.project["package"], c.files.project["package"]);return _context.abrupt("return",

            true);case 9:case "end":return _context.stop();}}}, _callee);}));return function checkIfTemplateConfigured(_x) {return _ref.apply(this, arguments);};}();exports.checkIfTemplateConfigured = checkIfTemplateConfigured;


var _cleanProjectTemplateSync = function _cleanProjectTemplateSync(c) {
  (0, _logger.logTask)('_cleanProjectTemplateSync');
  var dirsToRemove = [
  _path["default"].join(c.paths.project.appConfigBase.dir),
  _path["default"].join(c.paths.project.srcDir),
  _path["default"].join(c.paths.project.appConfigsDir)];


  var filesToRemove = c.buildConfig.defaults.supportedPlatforms.map(
  function (p) {return _path["default"].join(c.paths.project.dir, "index.".concat(p, ".js"));});


  (0, _fileutils.removeDirsSync)(dirsToRemove);
  // TODO: NOT SERVED FROM TEMPLATE YET
  (0, _fileutils.removeFilesSync)(filesToRemove);
};

var _applyTemplate = /*#__PURE__*/function () {var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(c) {return regeneratorRuntime.wrap(function _callee2$(_context2) {while (1) {switch (_context2.prev = _context2.next) {case 0:
            (0, _logger.logTask)('_applyTemplate', "current:".concat(c.buildConfig.currentTemplate, " selected:").concat(c.runtime.selectedTemplate));

            if (c.runtime.selectedTemplate) {
              _cleanProjectTemplateSync(c);
              // if (isMonorepo()) {
              //     // @todo - have the templates report their absolute locations
              //     c.paths.template.dir = path.join(
              //         getMonorepoRoot(),
              //         'packages',
              //         c.runtime.selectedTemplate
              //     );
              // } else {
              c.paths.template.dir = (0, _resolve.doResolve)(c.runtime.selectedTemplate);
              // c.paths.template.dir = path.join(c.paths.project.nodeModulesDir, c.runtime.selectedTemplate);
              // }
            } else {
              c.paths.template.dir = (0, _resolve.doResolve)(c.buildConfig.currentTemplate);
              // c.paths.template.dir = path.join(c.paths.project.nodeModulesDir, c.buildConfig.currentTemplate);
            }

            c.paths.template.configTemplate = _path["default"].join(
            c.paths.template.dir,
            _constants.RENATIVE_CONFIG_TEMPLATE_NAME);


            c.paths.template.config = _path["default"].join(
            c.paths.template.dir,
            _constants.RENATIVE_CONFIG_NAME);


            // if (fsExistsSync(c.paths.template.config)) {
            //     c.files.template.config = readObjectSync(c.paths.template.config);
            // }
            if (
            (0, _fileutils.fsExistsSync)(c.paths.template.configTemplate)) {_context2.next = 7;break;}
            (0, _logger.logWarning)("Template file ".concat(
            (0, _logger.chalk)().white(
            c.paths.template.configTemplate), " does not exist. check your ").concat(
            (0, _logger.chalk)().white(
            c.paths.template.dir), ". skipping"));return _context2.abrupt("return",


            true);case 7:


            (0, _logger.logDebug)("_applyTemplate:".concat(
            c.runtime.selectedTemplate, ":").concat(c.paths.template.dir));


            c.paths.template.appConfigsDir = _path["default"].join(
            c.paths.template.dir,
            'appConfigs');

            c.paths.template.appConfigBase.dir = _path["default"].join(
            c.paths.template.appConfigsDir,
            'base');

            c.runtime.currentTemplate = c.files.project.config.currentTemplate;
            if (!c.runtime.currentTemplate) {
              c.runtime.currentTemplate = Object.keys(
              c.files.project.config.templates)[
              0];
              c.runtime.requiresForcedTemplateApply = true;
            }return _context2.abrupt("return",

            true);case 13:case "end":return _context2.stop();}}}, _callee2);}));return function _applyTemplate(_x2) {return _ref2.apply(this, arguments);};}();


var _configureSrc = function _configureSrc(c) {return new Promise(function (resolve) {
    // Check src
    (0, _logger.logDebug)('configureProject:check src');
    if (!(0, _fileutils.fsExistsSync)(c.paths.project.srcDir)) {
      (0, _logger.logInfo)("Your src folder ".concat(
      (0, _logger.chalk)().white(
      c.paths.project.srcDir), " is missing! CREATING...DONE"));


      (0, _fileutils.copyFolderContentsRecursiveSync)(
      _path["default"].join(c.paths.template.dir, 'src'),
      c.paths.project.srcDir);

    }
    resolve();
  });};

var _configureAppConfigs = /*#__PURE__*/function () {var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(c) {var appConfigIds, _c$files$project, _c$files$project$conf, _c$files$project$conf2, supPlats;return regeneratorRuntime.wrap(function _callee3$(_context3) {while (1) {switch (_context3.prev = _context3.next) {case 0:
            // Check appConfigs
            (0, _logger.logDebug)('configureProject:check appConfigs');
            //
            if (!(0, _fileutils.fsExistsSync)(c.paths.project.appConfigsDir)) {
              (0, _logger.logInfo)("Your appConfig folder ".concat(
              (0, _logger.chalk)().white(
              c.paths.project.appConfigsDir), " is missing! ReNative will create one from template."));



              // TODO: GET CORRECT PROJECT TEMPLATE
              (0, _fileutils.copyFolderContentsRecursiveSync)(
              c.paths.template.appConfigsDir,
              c.paths.project.appConfigsDir);


              appConfigIds = (0, _configManager.listAppConfigsFoldersSync)(c, true);

              // Update App Title to match package.json
              try {
                supPlats = (_c$files$project = c.files.project) === null || _c$files$project === void 0 ? void 0 : (_c$files$project$conf = _c$files$project.config) === null || _c$files$project$conf === void 0 ? void 0 : (_c$files$project$conf2 = _c$files$project$conf.defaults) === null || _c$files$project$conf2 === void 0 ? void 0 : _c$files$project$conf2.supportedPlatforms;
                appConfigIds.forEach(function (v) {
                  var appConfigPath = _path["default"].join(
                  c.paths.project.appConfigsDir,
                  v,
                  _constants.RENATIVE_CONFIG_NAME);

                  var appConfig = (0, _fileutils.readObjectSync)(appConfigPath);
                  if (appConfig) {
                    appConfig.common = appConfig.common || {};
                    if (!c.runtime.isWrapper) {var _c$files$project$conf3, _c$files$project$conf4, _c$files$project$conf5, _c$files$project$conf6;
                      appConfig.common.title = (_c$files$project$conf3 = c.files.project.config) === null || _c$files$project$conf3 === void 0 ? void 0 : (_c$files$project$conf4 = _c$files$project$conf3.defaults) === null || _c$files$project$conf4 === void 0 ? void 0 : _c$files$project$conf4.title;
                      appConfig.common.id = (_c$files$project$conf5 = c.files.project.config) === null || _c$files$project$conf5 === void 0 ? void 0 : (_c$files$project$conf6 = _c$files$project$conf5.defaults) === null || _c$files$project$conf6 === void 0 ? void 0 : _c$files$project$conf6.id;
                    }

                    if (supPlats) {
                      Object.keys(appConfig.platforms).forEach(function (pk) {
                        if (!supPlats.includes(pk)) {
                          delete appConfig.platforms[pk];
                        }
                      });
                    }

                    _writeObjectSync(c, appConfigPath, appConfig);
                  }
                });
              } catch (e) {
                (0, _logger.logError)(e);
              }
            }case 2:case "end":return _context3.stop();}}}, _callee3);}));return function _configureAppConfigs(_x3) {return _ref3.apply(this, arguments);};}();


var _configureProjectConfig = function _configureProjectConfig(c) {return new Promise(function (resolve) {
    // Check projectConfigs
    (0, _logger.logDebug)('configureProject:check projectConfigs');
    if (!(0, _fileutils.fsExistsSync)(c.paths.project.appConfigBase.dir)) {
      (0, _logger.logInfo)("Your projectConfig folder ".concat(
      (0, _logger.chalk)().white(
      c.paths.project.appConfigBase.dir), " is missing! CREATING...DONE"));


      (0, _fileutils.copyFolderContentsRecursiveSync)(
      c.paths.template.appConfigBase.dir,
      c.paths.project.appConfigBase.dir);

    }
    resolve();
  });};

var _configureRenativeConfig = /*#__PURE__*/function () {var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(c) {var templateConfig, mergedObj;return regeneratorRuntime.wrap(function _callee4$(_context4) {while (1) {switch (_context4.prev = _context4.next) {case 0:
            // renative.json
            templateConfig = (0, _fileutils.readObjectSync)(c.paths.template.configTemplate);
            (0, _logger.logDebug)('configureProject:check renative.json');

            if (!c.runtime.isWrapper) {
              if (
              c.runtime.selectedTemplate ||
              c.runtime.requiresForcedTemplateApply ||
              c.files.project.config.isNew)
              {
                (0, _logger.logInfo)("Your ".concat(

                c.paths.project.config, " need to be updated with ").concat(
                c.paths.template.configTemplate, ". UPDATING...DONE"));

                mergedObj = (0, _fileutils.mergeObjects)(
                c,
                c.files.project.config,
                templateConfig,
                false,
                true);

                // Do not override supportedPlatforms
                mergedObj.defaults.supportedPlatforms = c.files.project.config.defaults.supportedPlatforms;
                // Do not override engines
                mergedObj.engines = c.files.project.config.engines;
                // Set current template
                mergedObj.currentTemplate = c.runtime.currentTemplate;
                if (mergedObj.isNew) {
                  c.runtime.isFirstRunAfterNew = true;
                }
                mergedObj.isNew = null;
                delete mergedObj.isNew;
                c.files.project.config = mergedObj;
                _writeObjectSync(c, c.paths.project.config, mergedObj);
              }
            } else {
              // if (templateConfig.plugins.renative) {
              //     templateConfig.plugins.renative = getLocalRenativePlugin();
              // }
              templateConfig.plugins.renative = {
                webpack: {
                  modulePaths: [
                  {
                    projectPath: '../../packages/renative' }],


                  moduleAliases: {
                    renative: {
                      projectPath: '../../packages/renative' } } } };




              c.files.project.configLocal = templateConfig;
              (0, _configManager.generateLocalConfig)(c);
              // _writeObjectSync(c, c.paths.project.configLocal, templateConfig);
            }return _context4.abrupt("return",
            true);case 4:case "end":return _context4.stop();}}}, _callee4);}));return function _configureRenativeConfig(_x4) {return _ref4.apply(this, arguments);};}();


var configureTemplateFiles = /*#__PURE__*/function () {var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(c) {var _templateConfig$templ;var templateConfig, includedPaths;return regeneratorRuntime.wrap(function _callee5$(_context5) {while (1) {switch (_context5.prev = _context5.next) {case 0:
            (0, _logger.logTask)('configureTemplateFiles');

            templateConfig = (0, _fileutils.readObjectSync)(c.paths.template.configTemplate);


            includedPaths = templateConfig === null || templateConfig === void 0 ? void 0 : (_templateConfig$templ = templateConfig.templateConfig) === null || _templateConfig$templ === void 0 ? void 0 : _templateConfig$templ.includedPaths;
            if (includedPaths) {
              includedPaths.forEach(function (name) {
                var sourcePath = _path["default"].join(c.paths.template.dir, name);
                var destPath = _path["default"].join(c.paths.project.dir, name);
                if (!(0, _fileutils.fsExistsSync)(destPath) && (0, _fileutils.fsExistsSync)(sourcePath)) {
                  try {
                    if ((0, _fileutils.fsLstatSync)(sourcePath).isDirectory()) {
                      (0, _logger.logInfo)("Missing directory ".concat(
                      (0, _logger.chalk)().white("".concat(
                      destPath, ".js")), ". COPYING from TEMPATE...DONE"));


                      (0, _fileutils.copyFolderContentsRecursiveSync)(
                      sourcePath,
                      destPath);

                    } else {
                      (0, _logger.logInfo)("Missing file ".concat(
                      (0, _logger.chalk)().white("".concat(
                      destPath, ".js")), ". COPYING from TEMPATE...DONE"));


                      (0, _fileutils.copyFileSync)(sourcePath, destPath);
                    }
                  } catch (e) {
                    // Get some beer and order hookers
                  }
                }
              });
            }case 4:case "end":return _context5.stop();}}}, _callee5);}));return function configureTemplateFiles(_x5) {return _ref5.apply(this, arguments);};}();exports.configureTemplateFiles = configureTemplateFiles;


var configureEntryPoint = /*#__PURE__*/function () {var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(c, platform) {var entryFile, source, backupSource, dest;return regeneratorRuntime.wrap(function _callee6$(_context6) {while (1) {switch (_context6.prev = _context6.next) {case 0:
            (0, _logger.logTask)('configureEntryPoint');if (!

            c.files.project.config.isTemplate) {_context6.next = 3;break;}return _context6.abrupt("return", true);case 3:

            entryFile = (0, _common.getConfigProp)(c, platform, 'entryFile');_context6.prev = 4;


            source = _path["default"].join(
            c.paths.template.dir, "".concat(
            entryFile, ".js"));

            backupSource = _path["default"].join(
            c.paths.rnv.projectTemplate.dir,
            'entry', "".concat(
            entryFile, ".js"));

            dest = _path["default"].join(c.paths.project.dir, "".concat(entryFile, ".js"));
            if (!(0, _fileutils.fsExistsSync)(dest)) {
              if (!entryFile) {
                (0, _logger.logWarning)("Missing entryFile key for ".concat(
                (0, _logger.chalk)().white(
                c.platform), " platform in your ").concat(
                (0, _logger.chalk)().white(
                c.paths.appConfig.config), "."));


              } else if (!(0, _fileutils.fsExistsSync)(source)) {
                (0, _logger.logInfo)("Missing entry file ".concat(
                (0, _logger.chalk)().white("".concat(
                entryFile, ".js")), ". COPYING from RNV...DONE"));


                (0, _fileutils.copyFileSync)(backupSource, dest);
              } else {
                (0, _logger.logInfo)("Missing entry file ".concat(
                (0, _logger.chalk)().white("".concat(
                entryFile, ".js")), ". COPYING from TEMPATE...DONE"));


                (0, _fileutils.copyFileSync)(source, dest);
              }
            }_context6.next = 14;break;case 11:_context6.prev = 11;_context6.t0 = _context6["catch"](4);return _context6.abrupt("return",

            Promise.reject(_context6.t0));case 14:return _context6.abrupt("return",


            true);case 15:case "end":return _context6.stop();}}}, _callee6, null, [[4, 11]]);}));return function configureEntryPoint(_x6, _x7) {return _ref6.apply(this, arguments);};}();exports.configureEntryPoint = configureEntryPoint;


var _writeObjectSync = function _writeObjectSync(c, p, s) {
  (0, _fileutils.writeFileSync)(p, s);
  (0, _configManager.generateBuildConfig)(c);
};

var getTemplateOptions = function getTemplateOptions(c, isGlobalScope) {
  var defaultProjectTemplates;
  if (isGlobalScope) {
    defaultProjectTemplates = c.files.rnv.projectTemplates.config.projectTemplates;
  } else {
    defaultProjectTemplates = c.buildConfig.projectTemplates || {};
  }

  return (0, _prompt.generateOptions)(
  defaultProjectTemplates,
  false,
  null,
  function (i, obj, mapping, defaultVal) {var _c$buildConfig$templa;
    var exists = (_c$buildConfig$templa = c.buildConfig.templates) === null || _c$buildConfig$templa === void 0 ? void 0 : _c$buildConfig$templa[defaultVal];
    var installed = exists ? (0, _logger.chalk)().yellow(' (installed)') : '';
    return " [".concat((0, _logger.chalk)().grey(i + 1), "]> ").concat((0, _logger.chalk)().bold(
    defaultVal)).concat(
    installed, " \n");
  });

};exports.getTemplateOptions = getTemplateOptions;

var getInstalledTemplateOptions = function getInstalledTemplateOptions(c) {
  if (c.files.project.config.isTemplate) return [];
  if (c.buildConfig.templates) {
    return (0, _prompt.generateOptions)(c.buildConfig.templates);
  }
  (0, _logger.logError)("You don't have any local templates installed", false, true);
  return [];
};exports.getInstalledTemplateOptions = getInstalledTemplateOptions;

var isTemplateInstalled = function isTemplateInstalled(c) {return c.buildConfig.currentTemplate ? (0, _resolve.doResolve)(c.buildConfig.currentTemplate) : false;};exports.isTemplateInstalled = isTemplateInstalled;


var applyTemplate = /*#__PURE__*/function () {var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(c, selectedTemplate) {var opts, _yield$inquirer$promp, template, templateIsInstalled;return regeneratorRuntime.wrap(function _callee7$(_context7) {while (1) {switch (_context7.prev = _context7.next) {case 0:
            (0, _logger.logTask)(
            'applyTemplate', "".concat(c.buildConfig.currentTemplate, "=>").concat(selectedTemplate));if (!

            c.files.project.config.isTemplate) {_context7.next = 3;break;}return _context7.abrupt("return", true);case 3:

            c.runtime.selectedTemplate = selectedTemplate;if (

            c.buildConfig.currentTemplate) {_context7.next = 14;break;}
            (0, _logger.logWarning)("You don't have any current template selected");
            opts = getInstalledTemplateOptions(c);_context7.next = 9;return (

              _inquirer["default"].prompt({
                type: 'list',
                name: 'template',
                message: 'Pick which template to apply',
                choices: opts.keysAsArray }));case 9:_yield$inquirer$promp = _context7.sent;template = _yield$inquirer$promp.template;


            c.buildConfig.currentTemplate = template;
            c.files.project.config.currentTemplate = template;
            _writeObjectSync(c, c.paths.project.config, c.files.project.config);case 14:


            templateIsInstalled = (0, _resolve.doResolve)(c.buildConfig.currentTemplate);if (
            templateIsInstalled) {_context7.next = 18;break;}_context7.next = 18;return (

              (0, _npmUtils.checkIfProjectAndNodeModulesExists)(c));case 18:_context7.next = 20;return (


              _applyTemplate(c));case 20:_context7.next = 22;return (
              _configureSrc(c));case 22:_context7.next = 24;return (
              _configureAppConfigs(c));case 24:_context7.next = 26;return (
              _configureProjectConfig(c));case 26:_context7.next = 28;return (
              _configureRenativeConfig(c));case 28:case "end":return _context7.stop();}}}, _callee7);}));return function applyTemplate(_x8, _x9) {return _ref7.apply(this, arguments);};}();exports.applyTemplate = applyTemplate;
//# sourceMappingURL=index.js.map