"use strict";Object.defineProperty(exports, "__esModule", { value: true });exports.taskRnvPlatformConfigure = exports["default"] = void 0;var _logger = require("../../core/systemManager/logger");
var _fileutils = require("../../core/systemManager/fileutils");
var _common = require("../../core/common");
var _schemeParser = require("../../core/configManager/schemeParser");
var _platformManager = require("../../core/platformManager");
var _packageParser = require("../../core/configManager/packageParser");
var _runtimeManager = require("../../core/runtimeManager");
var _taskManager = require("../../core/taskManager");
var _constants = require("../../core/constants");

var _installer = require("../../core/sdkManager/installer");function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {try {var info = gen[key](arg);var value = info.value;} catch (error) {reject(error);return;}if (info.done) {resolve(value);} else {Promise.resolve(value).then(_next, _throw);}}function _asyncToGenerator(fn) {return function () {var self = this,args = arguments;return new Promise(function (resolve, reject) {var gen = fn.apply(self, args);function _next(value) {asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);}function _throw(err) {asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);}_next(undefined);});};}

var taskRnvPlatformConfigure = /*#__PURE__*/function () {var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(c, parentTask, originTask) {var hasBuild;return regeneratorRuntime.wrap(function _callee$(_context) {while (1) {switch (_context.prev = _context.next) {case 0:
            (0, _logger.logTask)('taskRnvPlatformConfigure', '');_context.next = 3;return (

              (0, _taskManager.executeTask)(c, _constants.TASK_PROJECT_CONFIGURE, _constants.TASK_PLATFORM_CONFIGURE, originTask));case 3:_context.next = 5;return (

              (0, _platformManager.isPlatformSupported)(c));case 5:_context.next = 7;return (
              (0, _schemeParser.isBuildSchemeSupported)(c));case 7:_context.next = 9;return (
              (0, _installer.checkSdk)(c));case 9:_context.next = 11;return (
              (0, _runtimeManager.configureRuntimeDefaults)(c));case 11:if (!(

            c.program.only && !!parentTask)) {_context.next = 13;break;}return _context.abrupt("return", true);case 13:_context.next = 15;return (

              (0, _taskManager.executeTask)(c, _constants.TASK_INSTALL, _constants.TASK_PLATFORM_CONFIGURE, originTask));case 15:

            hasBuild = (0, _fileutils.fsExistsSync)(c.paths.project.builds.dir);
            (0, _logger.logTask)('', "taskRnvPlatformConfigure hasBuildFolderPresent:".concat(hasBuild));if (!(

            (c.program.reset || c.program.resetHard) && !c.runtime.disableReset)) {_context.next = 21;break;}
            (0, _logger.logInfo)("You passed ".concat(
            (0, _logger.chalk)().white(c.program.reset ? '-r' : '-R'), " argument. \"").concat((0, _logger.chalk)().white((0, _common.getAppFolder)(c, c.platform)), "\" CLEANING...DONE"));_context.next = 21;return (

              (0, _platformManager.cleanPlatformBuild)(c, c.platform));case 21:_context.next = 23;return (


              (0, _platformManager.createPlatformBuild)(c, c.platform));case 23:_context.next = 25;return (
              (0, _packageParser.injectPlatformDependencies)(c));case 25:return _context.abrupt("return",

            true);case 26:case "end":return _context.stop();}}}, _callee);}));return function taskRnvPlatformConfigure(_x, _x2, _x3) {return _ref.apply(this, arguments);};}();exports.taskRnvPlatformConfigure = taskRnvPlatformConfigure;var _default =


{
  description: '',
  fn: taskRnvPlatformConfigure,
  task: 'platform configure',
  params: _constants.PARAMS.withBase(),
  platforms: [] };exports["default"] = _default;
//# sourceMappingURL=task.rnv.platform.configure.js.map